const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Expense_reportsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expense_reports = await db.expense_reports.create(
      {
        id: data.id || undefined,

        submitted_at: data.submitted_at || null,
        status: data.status || null,
        policy_result: data.policy_result || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await expense_reports.setEmployee(data.employee || null, {
      transaction,
    });

    await expense_reports.setOrganizations(data.organizations || null, {
      transaction,
    });

    return expense_reports;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const expense_reportsData = data.map((item, index) => ({
      id: item.id || undefined,

      submitted_at: item.submitted_at || null,
      status: item.status || null,
      policy_result: item.policy_result || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const expense_reports = await db.expense_reports.bulkCreate(
      expense_reportsData,
      { transaction },
    );

    // For each item created, replace relation files

    return expense_reports;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const expense_reports = await db.expense_reports.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.submitted_at !== undefined)
      updatePayload.submitted_at = data.submitted_at;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.policy_result !== undefined)
      updatePayload.policy_result = data.policy_result;

    updatePayload.updatedById = currentUser.id;

    await expense_reports.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await expense_reports.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await expense_reports.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return expense_reports;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expense_reports = await db.expense_reports.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of expense_reports) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of expense_reports) {
        await record.destroy({ transaction });
      }
    });

    return expense_reports;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expense_reports = await db.expense_reports.findByPk(id, options);

    await expense_reports.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await expense_reports.destroy({
      transaction,
    });

    return expense_reports;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const expense_reports = await db.expense_reports.findOne(
      { where },
      { transaction },
    );

    if (!expense_reports) {
      return expense_reports;
    }

    const output = expense_reports.get({ plain: true });

    output.expense_lines_report = await expense_reports.getExpense_lines_report(
      {
        transaction,
      },
    );

    output.employee = await expense_reports.getEmployee({
      transaction,
    });

    output.organizations = await expense_reports.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.policy_result) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'expense_reports',
            'policy_result',
            filter.policy_result,
          ),
        };
      }

      if (filter.submitted_atRange) {
        const [start, end] = filter.submitted_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            submitted_at: {
              ...where.submitted_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            submitted_at: {
              ...where.submitted_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.expense_reports.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('expense_reports', 'status', query),
        ],
      };
    }

    const records = await db.expense_reports.findAll({
      attributes: ['id', 'status'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['status', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.status,
    }));
  }
};
